/*******************************************************
* Creator: Martin Rudefelt
* Portability: non-native
*-------------------------------------------------------
* 
*******************************************************/

#include "EMGlobals.h"

#ifndef __COMMAND_IDS
#define __COMMAND_IDS

#include "EMCommandRepository.h"

// All commands have an offset (since they sometimes are sent as messages)
#define COMMAND_BASE_OFFSET 0//0x4000
#define MEDIA_COMMAND_BASE_OFFSET 500//0x2000
#define NETWORK_COMMAND_BASE_OFFSET 1000//0x8000
#define PROJECT_COMMAND_BASE_OFFSET 1500
#define MEDIA_INFO_COMMAND_BASE_OFFSET 2000
#define NETWORK_INFO_COMMAND_BASE_OFFSET 2500

const uint32 COMMAND_EXPAND_TRACK_INFO = COMMAND_BASE_OFFSET + 1;
const uint32 COMMAND_EXPAND_TIMELINE = COMMAND_BASE_OFFSET + 2;
const uint32 COMMAND_ADD_G_AUDIO_TRACK = COMMAND_BASE_OFFSET + 3;
const uint32 COMMAND_ADD_G_AUDIO_CLIP = COMMAND_BASE_OFFSET + 4;
const uint32 COMMAND_ZOOM_IN_TRACK_VERTICAL = COMMAND_BASE_OFFSET + 5;
const uint32 COMMAND_ZOOM_OUT_TRACK_VERTICAL = COMMAND_BASE_OFFSET + 6;
const uint32 COMMAND_MOVE_CLIPS = COMMAND_BASE_OFFSET + 7;
const uint32 COMMAND_CLONE_CLIPS = COMMAND_BASE_OFFSET + 8;
const uint32 COMMAND_DELETE_CLIPS = COMMAND_BASE_OFFSET + 9;
const uint32 COMMAND_ZOOM_IN_HORIZONTAL = COMMAND_BASE_OFFSET + 10;
const uint32 COMMAND_ZOOM_OUT_HORIZONTAL = COMMAND_BASE_OFFSET + 11;
const uint32 COMMAND_TOGGLE_RELATIVE_MOVE = COMMAND_BASE_OFFSET + 12;
const uint32 COMMAND_TOGGLE_SNAPPING = COMMAND_BASE_OFFSET + 13;
const uint32 COMMAND_MOVE_TRACKS = COMMAND_BASE_OFFSET + 14;
const uint32 COMMAND_ADD_G_VIDEO_TRACK = COMMAND_BASE_OFFSET + 15;
const uint32 COMMAND_ADD_G_VIDEO_CLIP = COMMAND_BASE_OFFSET + 16;
const uint32 COMMAND_LOAD_MEDIA = COMMAND_BASE_OFFSET + 17;
const uint32 COMMAND_CREATE_PROJECT = COMMAND_BASE_OFFSET + 18;
const uint32 COMMAND_DELETE_CLIPS_FROM_LIST = COMMAND_BASE_OFFSET + 19;
const uint32 COMMAND_TOGGLE_LOOP = COMMAND_BASE_OFFSET + 20;
const uint32 COMMAND_UNDO = COMMAND_BASE_OFFSET + 21;
const uint32 COMMAND_REDO = COMMAND_BASE_OFFSET + 22;
const uint32 COMMAND_PLAY = COMMAND_BASE_OFFSET + 23;
const uint32 COMMAND_STOP = COMMAND_BASE_OFFSET + 24;
const uint32 COMMAND_PROJECT_BEGIN = COMMAND_BASE_OFFSET + 25;
const uint32 COMMAND_PROJECT_END = COMMAND_BASE_OFFSET + 26;
const uint32 COMMAND_REGION_BEGIN = COMMAND_BASE_OFFSET + 27;
const uint32 COMMAND_REGION_END = COMMAND_BASE_OFFSET + 28;
const uint32 COMMAND_REWIND = COMMAND_BASE_OFFSET + 29;
const uint32 COMMAND_FAST_FORWARD = COMMAND_BASE_OFFSET + 30;
const uint32 COMMAND_ZOOM_IN_TRACKS_VERTICAL = COMMAND_BASE_OFFSET + 31;
const uint32 COMMAND_ZOOM_OUT_TRACKS_VERTICAL = COMMAND_BASE_OFFSET + 32;
const uint32 COMMAND_PREPARE_RECORDING = COMMAND_BASE_OFFSET + 33;
const uint32 COMMAND_SET_CLIP_EDIT = COMMAND_BASE_OFFSET + 34;
const uint32 COMMAND_SET_TRACK_EDIT = COMMAND_BASE_OFFSET + 35;
const uint32 COMMAND_SET_FX_EDIT = COMMAND_BASE_OFFSET + 36;
const uint32 COMMAND_TOGGLE_ENABLE_MIDI = COMMAND_BASE_OFFSET + 37;
const uint32 COMMAND_TOGGLE_EXPERT_MODE = COMMAND_BASE_OFFSET + 38;
const uint32 COMMAND_EXPAND_UTILITY_VIEW = COMMAND_BASE_OFFSET + 39;
const uint32 COMMAND_UTILITY_BUTTON_PRESSED = COMMAND_BASE_OFFSET + 40;
const uint32 COMMAND_GET_G_TRACK_INDEX = COMMAND_BASE_OFFSET + 41;
const uint32 COMMAND_TOGGLE_PLAYBACK = COMMAND_BASE_OFFSET + 42;
const uint32 COMMAND_CUT_CLIPS = COMMAND_BASE_OFFSET + 43;
const uint32 COMMAND_OPEN_PROJECT = COMMAND_BASE_OFFSET + 44;
const uint32 COMMAND_SAVE_PROJECT = COMMAND_BASE_OFFSET + 45;
const uint32 COMMAND_MESSAGE_SENDER = COMMAND_BASE_OFFSET + 46;
const uint32 COMMAND_DISPLAY_NEW_PROJECT_DIALOG = COMMAND_BASE_OFFSET + 47;
const uint32 COMMAND_SET_DEFAULT_SETTINGS = COMMAND_BASE_OFFSET + 48;
const uint32 COMMAND_DISPLAY_RENDER_FORMAT_DIALOG = COMMAND_BASE_OFFSET + 49;
const uint32 COMMAND_WRITE_STATUS_BAR_MESSAGE = COMMAND_BASE_OFFSET + 50;
const uint32 COMMAND_ADD_AUDIO_TRACK = COMMAND_BASE_OFFSET + 51;
const uint32 COMMAND_ADD_VIDEO_TRACK = COMMAND_BASE_OFFSET + 52;
const uint32 COMMAND_DELETE_TRACKS = COMMAND_BASE_OFFSET + 53;
const uint32 COMMAND_GET_TRACK_GUI_INDEX = COMMAND_BASE_OFFSET + 54;
const uint32 COMMAND_DISPLAY_EXPORT_MEDIA_DIALOG = COMMAND_BASE_OFFSET + 55;
const uint32 COMMAND_TOGGLE_NOVICE_MODE = COMMAND_BASE_OFFSET + 56;
const uint32 COMMAND_ADD_G_TRANSITION_TRACK = COMMAND_BASE_OFFSET + 57;
const uint32 COMMAND_ADD_TRANSITION_TRACK = COMMAND_BASE_OFFSET + 58;
const uint32 COMMAND_DISPLAY_CHANGE_CLIP_NAME_DIALOG = COMMAND_BASE_OFFSET + 59;
const uint32 COMMAND_DISPLAY_CLIP_PROPERTIES_DIALOG = COMMAND_BASE_OFFSET + 60;
const uint32 COMMAND_DISPLAY_EXPORT_MEDIA_SETTINGS_DIALOG = COMMAND_BASE_OFFSET + 61;
const uint32 COMMAND_DISPLAY_NORMALIZE_DIALOG = COMMAND_BASE_OFFSET + 62;
const uint32 COMMAND_DISPLAY_PROJECT_SETTINGS_DIALOG = COMMAND_BASE_OFFSET + 63;
const uint32 COMMAND_DISPLAY_QUANTIZE_DIALOG = COMMAND_BASE_OFFSET + 64;
const uint32 COMMAND_DISPLAY_SET_VELOCITY_DIALOG = COMMAND_BASE_OFFSET + 65;
const uint32 COMMAND_DISPLAY_SYSTEM_SETTINGS_DIALOG = COMMAND_BASE_OFFSET + 66;
const uint32 COMMAND_DISPLAY_TRANSPOSE_DIALOG = COMMAND_BASE_OFFSET + 67;
const uint32 COMMAND_DISPLAY_VIDEO_RECORDING_DIALOG = COMMAND_BASE_OFFSET + 68;
const uint32 COMMAND_DISPLAY_VIDEO_SPEED_DIALOG = COMMAND_BASE_OFFSET + 69;
const uint32 COMMAND_ADD_G_MIDI_TRACK = COMMAND_BASE_OFFSET + 70;
const uint32 COMMAND_ADD_MIDI_TRACK = COMMAND_BASE_OFFSET + 71;
const uint32 COMMAND_TOGGLE_ENABLE_AUDIO = COMMAND_BASE_OFFSET + 72;
const uint32 COMMAND_TOGGLE_ENABLE_VIDEO = COMMAND_BASE_OFFSET + 73;
const uint32 COMMAND_CHANGE_EXPLORER_LIST_VIEW_CONTROL_STYLE_TO_ICON = COMMAND_BASE_OFFSET + 74;
const uint32 COMMAND_CHANGE_EXPLORER_LIST_VIEW_CONTROL_STYLE_TO_SMALL_ICON = COMMAND_BASE_OFFSET + 75;
const uint32 COMMAND_CHANGE_EXPLORER_LIST_VIEW_CONTROL_STYLE_TO_LIST = COMMAND_BASE_OFFSET + 76;
const uint32 COMMAND_DISPLAY_ABOUT_DIALOG = COMMAND_BASE_OFFSET + 77;
const uint32 COMMAND_ADD_G_MIDI_CLIP = COMMAND_BASE_OFFSET + 78;
const uint32 UNDO_COMMAND_CHANGE_CLIP_SELECTION = COMMAND_BASE_OFFSET + 79;
const uint32 UNDO_COMMAND_CHANGE_CLIP_RESIZE = COMMAND_BASE_OFFSET + 80;
const uint32 COMMAND_DELETE_TRACKS_FROM_LIST = COMMAND_BASE_OFFSET + 81;
const uint32 COMMAND_TRACKS_SELECT_ALL = COMMAND_BASE_OFFSET + 82;
const uint32 COMMAND_TRACKS_SELECT_NONE = COMMAND_BASE_OFFSET + 83;
const uint32 COMMAND_TRACKS_SELECT_INVERT = COMMAND_BASE_OFFSET + 84;
const uint32 COMMAND_CLIPS_SELECT_ALL = COMMAND_BASE_OFFSET + 85;
const uint32 COMMAND_CLIPS_SELECT_NONE = COMMAND_BASE_OFFSET + 86;
const uint32 COMMAND_CLIPS_SELECT_INVERT = COMMAND_BASE_OFFSET + 87;
const uint32 COMMAND_TOGGLE_VIEW_CLIP_CONTENT = COMMAND_BASE_OFFSET + 88;
const uint32 COMMAND_MIDI_TOGGLE_METRONOME = COMMAND_BASE_OFFSET + 89;
const uint32 COMMAND_MIDI_QUICK_QUANTIZE = COMMAND_BASE_OFFSET + 90;
const uint32 COMMAND_MIDI_FIXED_LENGTH = COMMAND_BASE_OFFSET + 91;
const uint32 COMMAND_MIDI_RESET_DEVICES = COMMAND_BASE_OFFSET + 92;
const uint32 COMMAND_AUDIO_REVERSE = COMMAND_BASE_OFFSET + 93;
const uint32 COMMAND_AUDIO_CROP = COMMAND_BASE_OFFSET + 94;
const uint32 COMMAND_AUDIO_SILENCE = COMMAND_BASE_OFFSET + 95;
const uint32 COMMAND_AUDIO_FADE_IN = COMMAND_BASE_OFFSET + 96;
const uint32 COMMAND_AUDIO_FADE_OUT = COMMAND_BASE_OFFSET + 97;
const uint32 COMMAND_QUIT_APPLICATION = COMMAND_BASE_OFFSET + 98;
const uint32 COMMAND_MUTE_CLIPS = COMMAND_BASE_OFFSET + 99;
const uint32 COMMAND_GROUP_CLIPS = COMMAND_BASE_OFFSET + 100;
const uint32 COMMAND_UNGROUP_CLIPS = COMMAND_BASE_OFFSET + 101;
const uint32 COMMAND_SET_UNDO_TEXTS = COMMAND_BASE_OFFSET + 102;
const uint32 COMMAND_ACTIVE_MIDI_TRACK_STEP_DOWN = COMMAND_BASE_OFFSET + 103;
const uint32 COMMAND_ACTIVE_MIDI_TRACK_STEP_UP = COMMAND_BASE_OFFSET + 104;
const uint32 COMMAND_GROUP_CLIPS_FROM_LIST = COMMAND_BASE_OFFSET + 105;
const uint32 COMMAND_DISPLAY_TRANSITION_DIALOG = COMMAND_BASE_OFFSET + 106;
const uint32 COMMAND_ADD_TO_MEDIA_POOL_VIEW = COMMAND_BASE_OFFSET + 107;
const uint32 COMMAND_ADD_G_TRANSITION_CLIP = COMMAND_BASE_OFFSET + 108;
const uint32 COMMAND_DISPLAY_PROPERTY_PAGE_DIALOG = COMMAND_BASE_OFFSET + 109;
const uint32 COMMAND_DISPLAY_WIPE_TRANSITION_PROPERTIES_DIALOG = COMMAND_BASE_OFFSET + 110;
const uint32 COMMAND_CLEAR_UNDO_STACK = COMMAND_BASE_OFFSET + 111;
const uint32 COMMAND_MOVE_MIDI_EVENTS = COMMAND_BASE_OFFSET + 112;
const uint32 COMMAND_CLONE_MIDI_EVENTS = COMMAND_BASE_OFFSET + 113;
const uint32 UNDO_COMMAND_CHANGE_MIDI_EVENT_RESIZE = COMMAND_BASE_OFFSET + 114;
const uint32 UNDO_COMMAND_MOVE_RUBBERBAND_NODES = COMMAND_BASE_OFFSET + 115;
const uint32 UNDO_COMMAND_ADD_RUBBERBAND_NODES = COMMAND_BASE_OFFSET + 116;
const uint32 COMMAND_DELETE_MIDI_EVENTS = COMMAND_BASE_OFFSET + 117;
//const uint32 COMMAND_DELETE_RUBBERBAND_NODES = COMMAND_BASE_OFFSET + 118;
const uint32 COMMAND_DELETE_CLIPS_EVENTS_NODES = COMMAND_BASE_OFFSET + 119;
const uint32 UNDO_COMMAND_DELETE_RUBBERBAND_NODES = COMMAND_BASE_OFFSET + 120;
const uint32 COMMAND_GET_ENTRIES_FROM_MEDIA_POOL_VIEW = COMMAND_BASE_OFFSET + 121;
const uint32 COMMAND_AUDIO_LOCK_TO_TEMPO = COMMAND_BASE_OFFSET + 122;
const uint32 COMMAND_DISPLAY_SPLASH_SCREEN_TEXT = COMMAND_BASE_OFFSET + 123;
const uint32 COMMAND_TOGGLE_AUTO_QUANTIZE = COMMAND_BASE_OFFSET + 124;
const uint32 COMMAND_NEW_PROJECT = COMMAND_BASE_OFFSET + 125;
const uint32 UNDO_COMMAND_RESIZE_MIDI_EVENT = COMMAND_BASE_OFFSET + 126;
const uint32 COMMAND_CREATE_MIDI_EVENTS = COMMAND_BASE_OFFSET + 127;
const uint32 COMMAND_DISPLAY_LOGIN_DIALOG = COMMAND_BASE_OFFSET + 128;
const uint32 COMMAND_DISPLAY_AUDIO_EXTRACTION_CONVERSION_DIALOG = COMMAND_BASE_OFFSET + 129;
const uint32 COMMAND_CLOSE_AUDIO_EXTRACTION_CONVERSION_DIALOG = COMMAND_BASE_OFFSET + 130;
const uint32 COMMAND_SET_VALUE_IN_AUDIO_EXTRACTION_CONVERSION_DIALOG = COMMAND_BASE_OFFSET + 131;
const uint32 COMMAND_SET_BOTTOM_LABEL_IN_AUDIO_EXTRACTION_CONVERSION_DIALOG = COMMAND_BASE_OFFSET + 132;
const uint32 COMMAND_DISPLAY_COLOR_BALANCE_DIALOG = COMMAND_BASE_OFFSET + 133;
const uint32 COMMAND_SET_DEFAULT_SYSTEM_SETTINGS = COMMAND_BASE_OFFSET + 134;
const uint32 COMMAND_DISPLAY_HSV_VALUE_DIALOG = COMMAND_BASE_OFFSET + 135;
const uint32 COMMAND_CUT_MIDI_EVENTS = COMMAND_BASE_OFFSET + 136;
const uint32 COMMAND_GET_APPLICATION_DATA = COMMAND_BASE_OFFSET + 137;
const uint32 COMMAND_DISPLAY_EQ_DIALOG = COMMAND_BASE_OFFSET + 138;
const uint32 COMMAND_AUDIO_DESTRUCTIVE_FX = COMMAND_BASE_OFFSET + 139;
const uint32 COMMAND_AUDIO_NORMALIZE = COMMAND_BASE_OFFSET + 140;
const uint32 COMMAND_CHANGE_VIDEO_PLAYBACK_SPEED = COMMAND_BASE_OFFSET + 141;
const uint32 COMMAND_DISPLAY_SEARCH_ADD_USER_DIALOG = COMMAND_BASE_OFFSET + 142;
const uint32 COMMAND_DISPLAY_SEARCH_USER_DIALOG = COMMAND_BASE_OFFSET + 143;
const uint32 COMMAND_UPDATE_INSTANCE_IN_MEDIA_POOL_VIEW = COMMAND_BASE_OFFSET + 144;
const uint32 COMMAND_DELETE_ENTRY_FROM_MEDIA_POOL_VIEW = COMMAND_BASE_OFFSET + 145;
const uint32 COMMAND_POST_COMMAND = COMMAND_BASE_OFFSET + 146;
const uint32 COMMAND_DISPLAY_REGISTRATION_DIALOG = COMMAND_BASE_OFFSET + 147;

const uint32 MEDIA_COMMAND_TOGGLE_PLAYBACK = MEDIA_COMMAND_BASE_OFFSET + 1;
const uint32 MEDIA_COMMAND_START_PLAYBACK = MEDIA_COMMAND_BASE_OFFSET + 2;
const uint32 MEDIA_COMMAND_STOP_PLAYBACK = MEDIA_COMMAND_BASE_OFFSET + 3;
const uint32 MEDIA_COMMAND_SET_TRACK_MUTE_STATE = MEDIA_COMMAND_BASE_OFFSET + 4;
const uint32 MEDIA_COMMAND_TOGGLE_TRACK_SOLO = MEDIA_COMMAND_BASE_OFFSET + 5;
const uint32 MEDIA_COMMAND_SET_TRACK_PAN = MEDIA_COMMAND_BASE_OFFSET + 6;
const uint32 MEDIA_COMMAND_SET_TRACK_OUTPUT = MEDIA_COMMAND_BASE_OFFSET + 7;
const uint32 MEDIA_COMMAND_SET_TRACK_INPUT = MEDIA_COMMAND_BASE_OFFSET + 8;
const uint32 MEDIA_COMMAND_SET_TRACK_NAME = MEDIA_COMMAND_BASE_OFFSET + 9;
const uint32 MEDIA_COMMAND_SET_TRACK_FADER = MEDIA_COMMAND_BASE_OFFSET + 10;
const uint32 MEDIA_COMMAND_SET_CLIP_OUTPUT = MEDIA_COMMAND_BASE_OFFSET + 11;
const uint32 MEDIA_COMMAND_SEEK = MEDIA_COMMAND_BASE_OFFSET + 12;
const uint32 MEDIA_COMMAND_MOVE_CLIP = MEDIA_COMMAND_BASE_OFFSET + 13;
const uint32 MEDIA_COMMAND_IMPORT_MEDIA = MEDIA_COMMAND_BASE_OFFSET + 14;
const uint32 MEDIA_COMMAND_DROP_MEDIA = MEDIA_COMMAND_BASE_OFFSET + 15;
const uint32 MEDIA_COMMAND_CREATE_AUDIO_TRACK = MEDIA_COMMAND_BASE_OFFSET + 16;
const uint32 MEDIA_COMMAND_CREATE_VIDEO_TRACK = MEDIA_COMMAND_BASE_OFFSET + 17;
const uint32 MEDIA_COMMAND_DELETE_CLIP = MEDIA_COMMAND_BASE_OFFSET + 18;
const uint32 MEDIA_COMMAND_DELETE_TRACK = MEDIA_COMMAND_BASE_OFFSET + 19;
const uint32 MEDIA_COMMAND_CLONE_CLIP = MEDIA_COMMAND_BASE_OFFSET + 20;
const uint32 MEDIA_COMMAND_PREPARE_RECORDING = MEDIA_COMMAND_BASE_OFFSET + 21;
const uint32 MEDIA_COMMAND_TOGGLE_TRACK_ARM = MEDIA_COMMAND_BASE_OFFSET + 22;
const uint32 MEDIA_COMMAND_SET_CLIP_MARK_IN = MEDIA_COMMAND_BASE_OFFSET + 23;
const uint32 MEDIA_COMMAND_SET_CLIP_MARK_OUT = MEDIA_COMMAND_BASE_OFFSET + 24;
const uint32 MEDIA_COMMAND_SET_CLIP_NAME = MEDIA_COMMAND_BASE_OFFSET + 25;
const uint32 MEDIA_COMMAND_PLAY_BUFFER = MEDIA_COMMAND_BASE_OFFSET + 26;
const uint32 MEDIA_COMMAND_MOVE_TRACK = MEDIA_COMMAND_BASE_OFFSET + 27;
const uint32 MEDIA_COMMAND_SET_EFFECT_TRACK_OUTPUT = MEDIA_COMMAND_BASE_OFFSET + 28;
const uint32 MEDIA_COMMAND_INSERT_EFFECT = MEDIA_COMMAND_BASE_OFFSET + 29;
const uint32 MEDIA_COMMAND_CREATE_EFFECT_TRACK = MEDIA_COMMAND_BASE_OFFSET + 30;
const uint32 MEDIA_COMMAND_DELETE_VIDEO_CLIP_CONTENT = MEDIA_COMMAND_BASE_OFFSET + 31;
const uint32 MEDIA_COMMAND_CREATE_MIDI_TRACK = MEDIA_COMMAND_BASE_OFFSET + 32;
const uint32 MEDIA_COMMAND_SET_TRACK_MIDI_CHANNEL = MEDIA_COMMAND_BASE_OFFSET + 33;
const uint32 MEDIA_COMMAND_SET_ACTIVE_MIDI_TRACK = MEDIA_COMMAND_BASE_OFFSET + 34;
const uint32 MEDIA_COMMAND_SET_EFFECT = MEDIA_COMMAND_BASE_OFFSET + 35;
const uint32 MEDIA_COMMAND_CREATE_VIDEO_TRANSITION_TRACK = MEDIA_COMMAND_BASE_OFFSET + 36;
const uint32 MEDIA_COMMAND_ASSIGN_VIDEO_TRANSITION_TRACK = MEDIA_COMMAND_BASE_OFFSET + 37;
const uint32 MEDIA_COMMAND_DELETE_VIDEO_TRANSITION_TRACK = MEDIA_COMMAND_BASE_OFFSET + 38;
const uint32 MEDIA_COMMAND_CREATE_VIDEO_TRANSITION_CLIP = MEDIA_COMMAND_BASE_OFFSET + 39;
const uint32 MEDIA_COMMAND_RESIZE_VIDEO_TRANSITION_CLIP = MEDIA_COMMAND_BASE_OFFSET + 40;
const uint32 MEDIA_COMMAND_SET_VIDEO_TRANSITION = MEDIA_COMMAND_BASE_OFFSET + 41;
const uint32 MEDIA_COMMAND_SET_EFFECT_DRY_WET_MIX = MEDIA_COMMAND_BASE_OFFSET + 42;
const uint32 MEDIA_COMMAND_LOAD_EFFECT_PRESET = MEDIA_COMMAND_BASE_OFFSET + 43;
const uint32 MEDIA_COMMAND_SET_AUDIO_ENCODER = MEDIA_COMMAND_BASE_OFFSET + 44;
const uint32 MEDIA_COMMAND_SET_VIDEO_ENCODER = MEDIA_COMMAND_BASE_OFFSET + 45;
const uint32 MEDIA_COMMAND_DELETE_EFFECT = MEDIA_COMMAND_BASE_OFFSET + 46;
const uint32 MEDIA_COMMAND_SET_RENDER_TO_DISK_OUTPUT_FILENAME = MEDIA_COMMAND_BASE_OFFSET + 47;
const uint32 MEDIA_COMMAND_DELETE_MIDI_EVENTS = MEDIA_COMMAND_BASE_OFFSET + 48;
const uint32 MEDIA_COMMAND_MOVE_MIDI_EVENTS = MEDIA_COMMAND_BASE_OFFSET + 49;
const uint32 MEDIA_COMMAND_SET_RENDERING_FLAG = MEDIA_COMMAND_BASE_OFFSET + 50;
const uint32 MEDIA_COMMAND_SET_PERSIST_TRANSITION_SETTINGS = MEDIA_COMMAND_BASE_OFFSET + 51;
const uint32 MEDIA_COMMAND_SET_ENCODER_PROPERTY = MEDIA_COMMAND_BASE_OFFSET + 52;
const uint32 MEDIA_COMMAND_CREATE_MIDI_EVENT = MEDIA_COMMAND_BASE_OFFSET + 53;
const uint32 MEDIA_COMMAND_SHOW_EFFECT_DIALOG = MEDIA_COMMAND_BASE_OFFSET + 54;
const uint32 MEDIA_COMMAND_SET_VIDEO_WORKING_SIZE = MEDIA_COMMAND_BASE_OFFSET + 55;
const uint32 MEDIA_COMMAND_SET_PROJECT_BPM = MEDIA_COMMAND_BASE_OFFSET + 56;
const uint32 MEDIA_COMMAND_SET_AUDIO_RENDER_PARAMETERS = MEDIA_COMMAND_BASE_OFFSET + 57;
const uint32 MEDIA_COMMAND_RESIZE_MIDI_EVENT = MEDIA_COMMAND_BASE_OFFSET + 58;
const uint32 MEDIA_COMMAND_SEND_MIDI_EVENT = MEDIA_COMMAND_BASE_OFFSET + 59;
const uint32 MEDIA_COMMAND_SET_TRACK_VELOCITY_OFFSET = MEDIA_COMMAND_BASE_OFFSET + 60;
const uint32 MEDIA_COMMAND_SET_TRACK_KEY_OFFSET = MEDIA_COMMAND_BASE_OFFSET + 61;
const uint32 MEDIA_COMMAND_RESET_MIDI_DEVICES = MEDIA_COMMAND_BASE_OFFSET + 62;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_EDIT = MEDIA_COMMAND_BASE_OFFSET + 63;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_REVERSE = MEDIA_COMMAND_BASE_OFFSET + 64;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_CROP = MEDIA_COMMAND_BASE_OFFSET + 65;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_SILENCE = MEDIA_COMMAND_BASE_OFFSET + 66;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_NORMALIZE = MEDIA_COMMAND_BASE_OFFSET + 67;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_FADE_IN = MEDIA_COMMAND_BASE_OFFSET + 68;
const uint32 MEDIA_COMMAND_DESTRUCTIVE_FADE_OUT = MEDIA_COMMAND_BASE_OFFSET + 69;
const uint32 MEDIA_COMMAND_REFRESH_PREVIEW = MEDIA_COMMAND_BASE_OFFSET + 70;
const uint32 MEDIA_COMMAND_ADD_NODE = MEDIA_COMMAND_BASE_OFFSET + 71;
const uint32 MEDIA_COMMAND_DELETE_NODE = MEDIA_COMMAND_BASE_OFFSET + 72;
const uint32 MEDIA_COMMAND_MOVE_NODE = MEDIA_COMMAND_BASE_OFFSET + 73;
const uint32 MEDIA_COMMAND_SET_MAGIC_SPEED_VALUE = MEDIA_COMMAND_BASE_OFFSET + 74;
const uint32 MEDIA_COMMAND_SET_ENCODER_FAMILY = MEDIA_COMMAND_BASE_OFFSET + 75;
const uint32 MEDIA_COMMAND_QUANTIZE_MIDI_EVENTS = MEDIA_COMMAND_BASE_OFFSET + 76;

const uint32 MEDIA_INFO_COMMAND_GET_ENTRY_DURATION = MEDIA_INFO_COMMAND_BASE_OFFSET + 1;
const uint32 MEDIA_INFO_COMMAND_GET_OUTPUTS = MEDIA_INFO_COMMAND_BASE_OFFSET + 2;
const uint32 MEDIA_INFO_COMMAND_GET_INPUTS = MEDIA_INFO_COMMAND_BASE_OFFSET + 3;
const uint32 MEDIA_INFO_COMMAND_GET_OUTPUT_NAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 4;
const uint32 MEDIA_INFO_COMMAND_GET_INPUT_NAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 5;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_TRACK_IDS = MEDIA_INFO_COMMAND_BASE_OFFSET + 6;
const uint32 MEDIA_INFO_COMMAND_GET_SIGNAL_METER_VALUE = MEDIA_INFO_COMMAND_BASE_OFFSET + 7;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_ENTRY_ID = MEDIA_INFO_COMMAND_BASE_OFFSET + 8;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_NUM_CHANNELS = MEDIA_INFO_COMMAND_BASE_OFFSET + 9;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_MARK_IN = MEDIA_INFO_COMMAND_BASE_OFFSET + 10;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_MARK_OUT = MEDIA_INFO_COMMAND_BASE_OFFSET + 11;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_DURATION = MEDIA_INFO_COMMAND_BASE_OFFSET + 12;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_NAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 13;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_FILENAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 14;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_POSITION = MEDIA_INFO_COMMAND_BASE_OFFSET + 15;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_CLIP_HIGHRES_CONTENT = MEDIA_INFO_COMMAND_BASE_OFFSET + 16;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_CLIP_LOWRES_CONTENT = MEDIA_INFO_COMMAND_BASE_OFFSET + 17;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENTRY_NUM_CHANNELS = MEDIA_INFO_COMMAND_BASE_OFFSET + 18;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENTRY_NUM_SAMPLES = MEDIA_INFO_COMMAND_BASE_OFFSET + 19;
const uint32 MEDIA_INFO_COMMAND_GET_ENTRY_FILENAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 20;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_CLIP_CONTENT = MEDIA_INFO_COMMAND_BASE_OFFSET + 21;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_ASPECT_RATIO = MEDIA_INFO_COMMAND_BASE_OFFSET + 22;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_ENTRY_NUM_FRAMES = MEDIA_INFO_COMMAND_BASE_OFFSET + 23;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENTRY_FORMAT_STRING = MEDIA_INFO_COMMAND_BASE_OFFSET + 24;
const uint32 MEDIA_INFO_COMMAND_IS_PLAYING = MEDIA_INFO_COMMAND_BASE_OFFSET + 25;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_RENDER_OUTPUT = MEDIA_INFO_COMMAND_BASE_OFFSET + 26;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_RENDER_OUTPUT = MEDIA_INFO_COMMAND_BASE_OFFSET + 27;
const uint32 MEDIA_INFO_COMMAND_GET_TRACK_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 28;
const uint32 MEDIA_INFO_COMMAND_GET_CLIP_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 29;
const uint32 MEDIA_INFO_COMMAND_GET_ALL_TRACK_IDS = MEDIA_INFO_COMMAND_BASE_OFFSET + 30;
const uint32 MEDIA_INFO_COMMAND_GET_CODECS = MEDIA_INFO_COMMAND_BASE_OFFSET + 31;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_ENTRY_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 32;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 33;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_TRACK_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 34;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_TRACKS = MEDIA_INFO_COMMAND_BASE_OFFSET + 35; 
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_ENTRIES = MEDIA_INFO_COMMAND_BASE_OFFSET + 36;
const uint32 MEDIA_INFO_COMMAND_GET_ENTRY_USAGE_COUNT = MEDIA_INFO_COMMAND_BASE_OFFSET + 37;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENTRY_SAMPLE_RATE = MEDIA_INFO_COMMAND_BASE_OFFSET + 38;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENTRY_BIT_DEPTH = MEDIA_INFO_COMMAND_BASE_OFFSET + 39;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_ENTRY_FORMAT_STRING = MEDIA_INFO_COMMAND_BASE_OFFSET + 40;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_ENTRY_FRAME_RATE = MEDIA_INFO_COMMAND_BASE_OFFSET + 41;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_ENTRY_FRAME_SIZE = MEDIA_INFO_COMMAND_BASE_OFFSET + 42;
const uint32 MEDIA_INFO_COMMAND_GET_ALL_ENTRY_IDS = MEDIA_INFO_COMMAND_BASE_OFFSET + 43;
const uint32 MEDIA_INFO_COMMAND_GET_ENTRY_INFO = MEDIA_INFO_COMMAND_BASE_OFFSET + 44;
const uint32 MEDIA_INFO_COMMAND_GET_MIDI_SIGNAL_METER_VALUE = MEDIA_INFO_COMMAND_BASE_OFFSET + 45;
const uint32 MEDIA_INFO_COMMAND_GET_MIDI_TRACK_IDS = MEDIA_INFO_COMMAND_BASE_OFFSET + 46;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_TRACK_ID = MEDIA_INFO_COMMAND_BASE_OFFSET + 47;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_TRANSITION = MEDIA_INFO_COMMAND_BASE_OFFSET + 48;
const uint32 MEDIA_INFO_COMMAND_GET_NUMBER_OF_VIDEO_TRANSITIONS = MEDIA_INFO_COMMAND_BASE_OFFSET + 49;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_TRANSITION_IDS = MEDIA_INFO_COMMAND_BASE_OFFSET + 50;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_TRANSITION_NAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 51;
const uint32 MEDIA_INFO_COMMAND_GET_EFFECT_PRESETS = MEDIA_INFO_COMMAND_BASE_OFFSET + 52;
const uint32 MEDIA_INFO_COMMAND_GET_NATIVE_DIRECTX_EFFECT = MEDIA_INFO_COMMAND_BASE_OFFSET + 53;
const uint32 MEDIA_INFO_COMMAND_GET_AUDIO_ENCODERS = MEDIA_INFO_COMMAND_BASE_OFFSET + 54;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_AVI_ENCODERS = MEDIA_INFO_COMMAND_BASE_OFFSET + 55;
const uint32 MEDIA_INFO_COMMAND_GET_NUMBER_AUDIO_ENCODERS = MEDIA_INFO_COMMAND_BASE_OFFSET + 56;
const uint32 MEDIA_INFO_COMMAND_GET_NUMBER_VIDEO_AVI_ENCODERS = MEDIA_INFO_COMMAND_BASE_OFFSET + 57;
const uint32 MEDIA_INFO_COMMAND_GET_ENCODER_NAME = MEDIA_INFO_COMMAND_BASE_OFFSET + 58;
const uint32 MEDIA_INFO_COMMAND_GET_MIDI_EVENTS_FOR_CLIP = MEDIA_INFO_COMMAND_BASE_OFFSET + 59;
const uint32 MEDIA_INFO_COMMAND_GET_PERSIST_TRANSITION_SETTINGS = MEDIA_INFO_COMMAND_BASE_OFFSET + 60;
const uint32 MEDIA_INFO_COMMAND_GET_DEFAULT_TRANSITION_SETTINGS = MEDIA_INFO_COMMAND_BASE_OFFSET + 61;
const uint32 MEDIA_INFO_COMMAND_GET_ENCODER_PROPERTIES = MEDIA_INFO_COMMAND_BASE_OFFSET + 62;
const uint32 MEDIA_INFO_COMMAND_GET_ENCODER_PROPERTY_PAGE = MEDIA_INFO_COMMAND_BASE_OFFSET + 63;
const uint32 MEDIA_INFO_COMMAND_HAS_ENCODER_PROPERTY_PAGE = MEDIA_INFO_COMMAND_BASE_OFFSET + 64;
const uint32 MEDIA_INFO_COMMAND_GET_MIDI_EVENTS_FOR_TRACK = MEDIA_INFO_COMMAND_BASE_OFFSET + 65;
const uint32 MEDIA_INFO_COMMAND_GET_CURRENT_BITMAP = MEDIA_INFO_COMMAND_BASE_OFFSET + 66;
const uint32 MEDIA_INFO_COMMAND_DEVICE_EXISTS = MEDIA_INFO_COMMAND_BASE_OFFSET + 67;
const uint32 MEDIA_INFO_COMMAND_HAS_QUALITY = MEDIA_INFO_COMMAND_BASE_OFFSET + 68;
const uint32 MEDIA_INFO_COMMAND_GET_VIDEO_DIMENSION = MEDIA_INFO_COMMAND_BASE_OFFSET + 69;
const uint32 MEDIA_INFO_COMMAND_GET_NODES = MEDIA_INFO_COMMAND_BASE_OFFSET + 70;
const uint32 MEDIA_INFO_COMMAND_GET_INPUT_SIGNAL_METERS = MEDIA_INFO_COMMAND_BASE_OFFSET + 71;
const uint32 MEDIA_INFO_COMMAND_GET_MAGIC_SPEED_VALUE = MEDIA_INFO_COMMAND_BASE_OFFSET + 72;
const uint32 MEDIA_INFO_COMMAND_GET_CURRENT_PROJECT_POSITION = MEDIA_INFO_COMMAND_BASE_OFFSET + 73;
const uint32 MEDIA_INFO_COMMAND_GET_CURRENT_AUDIO_PROCESSING_POSITION = MEDIA_INFO_COMMAND_BASE_OFFSET + 74;
const uint32 MEDIA_INFO_COMMAND_GET_CURRENT_VIDEO_PROCESSING_POSITION = MEDIA_INFO_COMMAND_BASE_OFFSET + 75;

const uint32 NETWORK_COMMAND_SEND_MESSAGE = NETWORK_COMMAND_BASE_OFFSET + 1;
const uint32 NETWORK_COMMAND_SEND_FILE    = NETWORK_COMMAND_BASE_OFFSET + 2;
const uint32 NETWORK_COMMAND_RECEIVE_FILE = NETWORK_COMMAND_BASE_OFFSET + 3;
const uint32 NETWORK_COMMAND_FIND_USER = NETWORK_COMMAND_BASE_OFFSET + 4;
const uint32 NETWORK_COMMAND_ADD_USER = NETWORK_COMMAND_BASE_OFFSET + 5;
const uint32 NETWORK_COMMAND_DELETE_USER = NETWORK_COMMAND_BASE_OFFSET + 6;

const uint32 NETWORK_INFO_COMMAND_GET_MESSAGE			   = NETWORK_INFO_COMMAND_BASE_OFFSET + 1;
const uint32 NETWORK_INFO_COMMAND_USER_STATUS_MESSAGE	   = NETWORK_INFO_COMMAND_BASE_OFFSET + 2;
const uint32 NETWORK_INFO_COMMAND_NUMBER_OF_USERS		   = NETWORK_INFO_COMMAND_BASE_OFFSET + 3;
const uint32 NETWORK_INFO_COMMAND_GET_USER_INFOS		   = NETWORK_INFO_COMMAND_BASE_OFFSET + 4;
const uint32 NETWORK_INFO_COMMAND_GET_NEXT_FILE_INFO	   = NETWORK_INFO_COMMAND_BASE_OFFSET + 5;
const uint32 NETWORK_INFO_COMMAND_GET_NEXT_DOWNLOADED_FILE = NETWORK_INFO_COMMAND_BASE_OFFSET + 6;
const uint32 NETWORK_INFO_COMMAND_GET_NEXT_FOUND_USER = NETWORK_INFO_COMMAND_BASE_OFFSET + 7;

//About to be implemented...Not yet done however... /Richard
//const uint32 MEDIA_INFO_COMMAND_GET_EFFECTS = MEDIA_INFO_COMMAND_BASE_OFFSET + 36; //Fetches just the IDs of those effect instantiates (actually inside effect tracks). Same actual effect entry ID may of course appear more than once here!

const uint32 PROJECT_COMMAND_CREATE_PROJECT = PROJECT_COMMAND_BASE_OFFSET + 1;
const uint32 PROJECT_COMMAND_LOAD_PROJECT = PROJECT_COMMAND_BASE_OFFSET + 2;
const uint32 PROJECT_COMMAND_SAVE_PROJECT = PROJECT_COMMAND_BASE_OFFSET + 3;
const uint32 PROJECT_COMMAND_CLOSE_PROJECT = PROJECT_COMMAND_BASE_OFFSET + 4;
const uint32 PROJECT_COMMAND_GET_DIRECTORY = PROJECT_COMMAND_BASE_OFFSET + 5;
const uint32 PROJECT_COMMAND_ADD_PROJECT_DATA_CONTAINER = PROJECT_COMMAND_BASE_OFFSET + 6;
const uint32 PROJECT_COMMAND_READY_FOR_USE = PROJECT_COMMAND_BASE_OFFSET + 7;
const uint32 PROJECT_COMMAND_LOAD_TEMPLATE = PROJECT_COMMAND_BASE_OFFSET + 8;
const uint32 PROJECT_COMMAND_SAVE_NEEDED = PROJECT_COMMAND_BASE_OFFSET + 9;
const uint32 PROJECT_COMMAND_LOAD_SYSTEM_SETTINGS = PROJECT_COMMAND_BASE_OFFSET + 10;
const uint32 PROJECT_COMMAND_SAVE_SYSTEM_SETTINGS = PROJECT_COMMAND_BASE_OFFSET + 11;
const uint32 PROJECT_COMMAND_MOVE_PROJECT = PROJECT_COMMAND_BASE_OFFSET + 12;

#endif

