#ifndef __EM_MIDI_GLOBALS
#define __EM_MIDI_GLOBALS

enum EMMIDIMetronomeClickType
{
	EM_MIDI_METRONOME_TYPE_CLICK_HIGH,
	EM_MIDI_METRONOME_TYPE_CLICK_LOW,
};

enum EMMIDIDeviceDirection
{ 
	EM_MIDI_DIRECTION_IN, 
	EM_MIDI_DIRECTION_OUT,
	EM_MIDI_DIRECTION_THRU
};

/*const uint8 EM_MIDI_EVENT_NOTE_ON = 144;
const uint8 EM_MIDI_EVENT_CONTROL_MESSAGE = 176;
const uint8 EM_MIDI_EVENT_AFTERTOUCH = 208;
const uint8 EM_MIDI_EVENT_WHEEL = 224;

const uint32 EM_MESSAGE_MIDI_EVENT_RECEIVED = 696969;

const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_MODWHEEL1 = 1;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_FOOT_CONTROLLER = 4;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_DATA_ENTRY = 6;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_FOOT_VOLUME = 7;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_MODWHEEL2 = 13;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_SUSTAIN_PEDAL = 64;
const uint8 EM_MIDI_EVENT_CONTROLLER_MSG_MODULATION_FOOT_SWITCH = 65; */

enum EMMIDIEventType
{
	EM_MIDI_EVENT_TYPE_UNKNOWN = 0,
	EM_MIDI_EVENT_TYPE_NOTE_OFF = 128,
	EM_MIDI_EVENT_TYPE_NOTE_ON = 144,
	EM_MIDI_EVENT_TYPE_POLYPHONIC_AFTERTOUCH = 160,
	EM_MIDI_EVENT_TYPE_CONTROL_CHANGE = 176,
	EM_MIDI_EVENT_TYPE_PROGRAM_CHANGE = 192,
	EM_MIDI_EVENT_TYPE_CHANNEL_AFTERTOUCH = 208,
	EM_MIDI_EVENT_TYPE_PITCH_WHEEL_CONTROL = 224,
	EM_MIDI_EVENT_TYPE_SYSTEM_EXCLUSIVE = 240,
	EM_MIDI_EVENT_TYPE_MIDI_TIME_CODE_QTR_FRAME = 241,
	EM_MIDI_EVENT_TYPE_SONG_POSITION_POINTER = 242,
	EM_MIDI_EVENT_TYPE_SONG_SELECT = 243,
	EM_MIDI_EVENT_TYPE_UNDEFINED1 = 244,
	EM_MIDI_EVENT_TYPE_UNDEFINED2 = 245,
	EM_MIDI_EVENT_TYPE_TUNE_REQUEST = 246,
	EM_MIDI_EVENT_TYPE_END_OF_SYSEX = 247,
	EM_MIDI_EVENT_TYPE_TIMING_CLOCK = 248,
	EM_MIDI_EVENT_TYPE_UNDEFINED3 = 249,
	EM_MIDI_EVENT_TYPE_START = 250,
	EM_MIDI_EVENT_TYPE_CONTINUE = 251,
	EM_MIDI_EVENT_TYPE_STOP = 252,
	EM_MIDI_EVENT_TYPE_UNDEFINED4 = 253,
	EM_MIDI_EVENT_TYPE_ACTIVE_SENSING = 254,
	EM_MIDI_EVENT_TYPE_SYSTEM_RESET = 255
};

enum EMMIDIControlChangeType
{
	EM_MIDI_CONTROL_CHANGE_TYPE_UNKNOWN = 255,
	EM_MIDI_CONTROL_CHANGE_TYPE_BANK_SELECT_MSB = 0,
	EM_MIDI_CONTROL_CHANGE_TYPE_MODULATION_WHEEL_MSB = 1,
	EM_MIDI_CONTROL_CHANGE_TYPE_BREATH_CONTROL_MSB = 2,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_FOOT_CONTROLLER_MSB = 4,
	EM_MIDI_CONTROL_CHANGE_TYPE_PORTAMENTO_TIME_MSB = 5,
	EM_MIDI_CONTROL_CHANGE_TYPE_DATA_ENTRY_MSB = 6,
	EM_MIDI_CONTROL_CHANGE_TYPE_CHANNEL_VOLUME_MSB = 7,
	EM_MIDI_CONTROL_CHANGE_TYPE_BALANCE_MSB = 8,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_PAN_MSB = 10,
	EM_MIDI_CONTROL_CHANGE_TYPE_EXPRESSION_CONTROLLER_MSB = 11,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECT_CONTROL_1_MSB = 12,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECT_CONTROL_2_MSB = 13,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_1_MSB = 16,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_2_MSB = 17,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_3_MSB = 18,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_4_MSB = 19,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_BANK_SELECT_LSB = 32,
	EM_MIDI_CONTROL_CHANGE_TYPE_MODULATION_WHEEL_LSB = 33,
	EM_MIDI_CONTROL_CHANGE_TYPE_BREATH_CONTROL_LSB = 34,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_FOOT_CONTROLLER_LSB = 36,
	EM_MIDI_CONTROL_CHANGE_TYPE_PORTAMENTO_TIME_LSB = 37,
	EM_MIDI_CONTROL_CHANGE_TYPE_DATA_ENTRY_LSB = 38,
	EM_MIDI_CONTROL_CHANGE_TYPE_CHANNEL_VOLUME_LSB = 39,
	EM_MIDI_CONTROL_CHANGE_TYPE_BALANCE_LSB = 40,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_PAN_LSB = 42,
	EM_MIDI_CONTROL_CHANGE_TYPE_EXPRESSION_CONTROLLER_LSB = 43,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECT_CONTROL_1_LSB = 44,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECT_CONTROL_2_LSB = 45,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_1_LSB = 48,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_2_LSB = 49,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_3_LSB = 50,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_4_LSB = 51,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_DAMPER_PEDAL = 64, 
	EM_MIDI_CONTROL_CHANGE_TYPE_PORTAMENTO = 65, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SUSTENUTO = 66, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOFT_PEDAL = 67, 
	EM_MIDI_CONTROL_CHANGE_TYPE_LEGATO_FOOTSWITCH = 68, 
	EM_MIDI_CONTROL_CHANGE_TYPE_HOLD_2 = 69, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_1 = 70, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_2 = 71, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_3 = 72, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_4 = 73, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_5 = 74, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_6 = 75, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_7 = 76, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_8 = 77, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_9 = 78, 
	EM_MIDI_CONTROL_CHANGE_TYPE_SOUND_CONTROL_10 = 79, 
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_5_LSB = 80,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_6_LSB = 81,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_7_LSB = 82,
	EM_MIDI_CONTROL_CHANGE_TYPE_GENERAL_PURPOSE_CONTROLLER_8_LSB = 83,
	EM_MIDI_CONTROL_CHANGE_TYPE_PORTAMENTO_CONTROL = 84,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_REVERB_SEND_LEVEL = 91,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECTS_2_DEPTH = 92,
	EM_MIDI_CONTROL_CHANGE_TYPE_CHORUS_SEND_LEVEL = 93,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECTS_4_DEPTH = 94,
	EM_MIDI_CONTROL_CHANGE_TYPE_EFFECTS_5_DEPTH = 95,
	EM_MIDI_CONTROL_CHANGE_TYPE_DATA_ENTRY_INC_ONE = 96,
	EM_MIDI_CONTROL_CHANGE_TYPE_DATA_ENTRY_DEC_ONE = 97,
	EM_MIDI_CONTROL_CHANGE_TYPE_NON_REGISTERED_PARAMETER_NUMBER_LSB = 98,
	EM_MIDI_CONTROL_CHANGE_TYPE_NON_REGISTERED_PARAMETER_NUMBER_MSB = 99,
	EM_MIDI_CONTROL_CHANGE_TYPE_REGISTERED_PARAMETER_NUMBER_LSB = 100,
	EM_MIDI_CONTROL_CHANGE_TYPE_REGISTERED_PARAMETER_NUMBER_MSB = 101,
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
/*	EM_MIDI_CONTROL_CHANGE_TYPE_UNDEFINED,*/
	EM_MIDI_CONTROL_CHANGE_TYPE_ALL_SOUND_OFF = 120,
	EM_MIDI_CONTROL_CHANGE_TYPE_RESET_ALL_CONTROLLERS = 121,
	EM_MIDI_CONTROL_CHANGE_TYPE_LOCAL_CONTROL = 122,
	EM_MIDI_CONTROL_CHANGE_TYPE_ALL_NOTES_OFF = 123,
	EM_MIDI_CONTROL_CHANGE_TYPE_OMNI_MODE_OFF = 124,
	EM_MIDI_CONTROL_CHANGE_TYPE_OMNI_MODE_ON = 125,
	EM_MIDI_CONTROL_CHANGE_TYPE_POLY_MODE_OFF = 126,
	EM_MIDI_CONTROL_CHANGE_TYPE_POLY_MODE_ON = 127
};

#endif